//@ sourceURL=request_type.js
$(function () {
    $(".selectpicker").selectpicker({
        dropuAuto: false
    });
    initMzyZdChargeTypeList();
    initReqTypeSelect();
    //新增号别分类
    $('#btn_req_type').click(function () {
        $("#MzyZdReqTypeModalTitle").html("新增号别分类");
        $("#MzyZdReqTypeModal").modal();
        $("#mzyZdReqTypeCode").val(null);
        $("#name").val(null);
    });

    //新增号别
    $('#btn_add').click(function () {
        $("#editModalTitle").html("新增号别");
        $("#editModal").modal();
        $("#mzyZdChargeTypeCode").val(null);
        clearInput();
    });

    //保存号别分类
    $('#saveMzyZdReqtype').click(function () {
        $.ajax({
            type: "POST",
            url: '/thmz/saveMzyZdReqType',
            contentType: "application/json;charset=UTF-8",
            dataType: "json",
            headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
            data: JSON.stringify({"code": $("#mzyZdReqTypeCode").val(),"name": $("#name").val()}),
            success: function (res) {
                if (res == '401' || res == 401) {
                    window.location.href = '/thmz/login/view'
                    return;
                }
                if (res.code == 0) {
                    $("#MzyZdReqTypeModal").modal("hide");
                    $("#mzyZdReqTypeCode").val(null);
                    $("#name").val(null);
                    successMesage(res);
                    initReqTypeSelect();
                    $('#tb_table').bootstrapTable("refresh");
                } else {
                    errorMesage(res);
                }
            }
        });
    });




    //保存号别
    $('#saveEdit').click(function () {
        $.ajax({
            type: "POST",
            url: '/thmz/saveMzyMzyZdChargeType',
            contentType: "application/json;charset=UTF-8",
            dataType: "json",
            headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
            data: JSON.stringify({"code": $("#mzyZdChargeTypeCode").val(),"name": $("#nameHb").val(),"reqType": $("#reqTypeSelect").val(),"sortNo": $("#sortNum").val(),"reqFee": $("#reqFee").val(),"clinicFee": $("#clinicFee").val(),"othFee": $("#otherFee").val()}),
            success: function (res) {
                if (res == '401' || res == 401) {
                    window.location.href = '/thmz/login/view'
                    return;
                }
                if (res.code == 0) {
                    $("#editModal").modal("hide");
                    $("#mzyZdChargeTypeCode").val(null);
                    clearInput();
                    successMesage(res);
                    $('#tb_table').bootstrapTable("refresh");
                } else {
                    errorMesage(res);
                }
            }
        });
    });





});

/**
 * 清空输入框
 */
function clearInput() {
    $("#nameHb").val(null);
    $('#reqTypeSelect').selectpicker('val', null);
    $('#chargeType').selectpicker('refresh');
    $("#sortNum").val(null);
    $("#reqFee").val(null);
    $("#clinicFee").val(null);
    $("#otherFee").val(null);
    $("#mzyZdChargeTypeCode").val(null);
}


/**
 * 号表类型切换事件
 * @param object
 */
function sourceChange(object) {
    $("#source_group").find("button").each(function (index, element) {
        if ($(element).hasClass("btn-primary")) {
            $(element).removeClass("btn-primary").addClass("btn-default");
        }
    });
    $(object).removeClass("btn-default").addClass("btn-primary");
    var sourceGroup = getIndex("source_group");
    if (sourceGroup == 0) {
        initMzyZdReqTypeList();
    } else {
        initMzyZdChargeTypeList();
    }
}


/**
 * 获取按钮组选择的下标
 * @param id
 * @returns {number}
 */
function getIndex(id) {
    var index = 0;
    var item = $("#" + id).find("button");
    for (var i = 0; i <= item.length; i++) {
        if ($(item[i]).hasClass("btn-primary")) {
            index = i;
            break;
        }
    }
    return index;
}

/**
 * 号别类别列表
 */
function initMzyZdReqTypeList() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/getMzyZdReqType',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "desc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "client",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 15,                       //每页的记录行数（*）
        pageList: [10, 15, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "ID",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                field: 'code',
                title: '类别编码',
                align: "center",
                valign: 'middle',
            }, {
                field: 'name',
                title: '类别名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'pyCode',
                title: '拼音码',
                align: "center",
                valign: 'middle'
            }, {
                field: 'wbCode',
                title: '五笔码',
                align: "center",
                valign: 'middle'
            },  {
                title: '操作',
                field: 'op',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick="updateMzyZdReqType(\'' + row.code + '\',\''+row.name+'\')">编辑</button>';
                    str += '<button type="button" class="btn btn-danger  btn-sm" onclick="deleteMzyZdReqType(\'' + row.code + '\')">删除</button>';
                    return [str].join('');
                }
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.data.length,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}


/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    return {};
};









/**
 * 号别列表
 */
function initMzyZdChargeTypeList() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/getAllMzChargeType',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "desc",                   //排序方式
        queryParams: queryMzyZdChargeTypeParams,           //传递参数（*）
        sidePagination: "client",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 15,                       //每页的记录行数（*）
        pageList: [10, 15, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "ID",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                field: 'code',
                title: '号别编码',
                align: "center",
                valign: 'middle',
            }, {
                field: 'name',
                title: '号别名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'reqType',
                title: '类别',
                align: "center",
                valign: 'middle'
            }, {
                field: 'sortNo',
                title: '排序吗',
                align: "center",
                valign: 'middle'
            }, {
                field: 'reqFee',
                title: '挂号费',
                align: "center",
                valign: 'middle'
            }, {
                field: 'clinicFee',
                title: '诊疗费',
                align: "center",
                valign: 'middle'
            }, {
                field: 'othFee',
                title: '其他费',
                align: "center",
                valign: 'middle'
            }, {
                field: 'pyCode',
                title: '拼音码',
                align: "center",
                valign: 'middle'
            }, {
                field: 'selfCode',
                title: '五笔码',
                align: "center",
                valign: 'middle'
            },  {
                title: '操作',
                field: 'op',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick="updateMzyZdChargeType(\'' + row.code + '\')">编辑</button>';
                    str += '<button type="button" class="btn btn-danger  btn-sm" onclick="deleteMzyZdChargeType(\'' + row.code + '\')">删除</button>';
                    return [str].join('');
                }
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.data.length,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}





/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryMzyZdChargeTypeParams(params) {
    return {};
};









/**
 * 修改号别类别
 * @param code
 */
function updateMzyZdReqType(code,name) {
    $("#MzyZdReqTypeModalTitle").html("编辑号别分类");
    $("#mzyZdReqTypeCode").val(code);
    $("#name").val(name);
    $("#MzyZdReqTypeModal").modal();
}





/**
 * 删除号别类别
 * @param code
 */
function deleteMzyZdReqType(code) {
    if (!confirm("确认要删除当前操作的号别类别信息吗？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/removeZdReqType?code=' + code,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                successMesage(res);
                initReqTypeSelect();
                $('#tb_table').bootstrapTable("refresh");
            }else {
                errorMesage(res);
            }
        }
    });
}






/**
 * 修改号别
 * @param code
 */
function updateMzyZdChargeType(code) {
    $("#editModalTitle").html("编辑号别");
    $.ajax({
        type: "GET",
        url: '/thmz/getMzChargeTypeByCode?code=' + code,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#nameHb").val(res.data.name);
                $('#reqTypeSelect').selectpicker('val', res.data.reqType);
                $('#chargeType').selectpicker('refresh');
                $("#sortNum").val(res.data.sortNo);
                $("#reqFee").val(res.data.reqFee);
                $("#clinicFee").val(res.data.clinicFee);
                $("#otherFee").val(res.data.othFee);
                $("#mzyZdChargeTypeCode").val(code);
                $("#editModal").modal();
            }else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 删除号别
 * @param code
 */
function deleteMzyZdChargeType(code) {
    if (!confirm("确认要删除当前操作的号别信息吗？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/removeMzyZdChargeType?code=' + code,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                successMesage(res);
                $('#tb_table').bootstrapTable("refresh");
            }else {
                errorMesage(res);
            }
        }
    });
}




/**
 * 号别类别列表初始化
 */
function initReqTypeSelect() {
    //号别类别列表
    $.ajax({
        type: "GET",
        url: '/thmz/getMzyZdReqType',
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var html = '';
            $.each(res.data, function (commentIndex, comment) {
                html += '<option value="' + comment.code + '">' + comment.name + '</option>';
            });
            $('#reqTypeSelect').empty();
            $('#reqTypeSelect').html(html);
            $('#reqTypeSelect').selectpicker('destroy').selectpicker('refresh');
        }
    });
}




//按数字大小排序
sortNum=  function(a, b) {
    var a = a?a:-1, b = b?b:-1
    return a-b
}